
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code
	.align 1
	.global draw_scanline_wz_color
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_wz_color:
	;// USAGE:
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v
	pushn %r2

	;// m :v0 -> v1:E Ƃ܂B
	ld.uh	%r4,[%r12]	; 	xld.uh %r4, [%r12+0]	;// v0->x
	ld.uh	%r5,[%r13]	; 	xld.uh %r5, [%r13+0]	;// v1->x
	cmp %r4, %r5
	jrule	__draw_scanline_wz_color_swap	; 	xjrule __draw_scanline_wz_color_swap
	xor %r12, %r13
	xor %r13, %r12
	xor %r12, %r13
__draw_scanline_wz_color_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	ld.uh	%r4,[%r14]	; 	xld.uh %r4, [%r14+0]	;// param->surface_w
	ext	0x2		; 	xld.uh %r5, [%r12+2]	;// v0->y
	ld.uh	%r5,[%r12]
	mltu.h %r4, %r5
	ld.w %r4, %alr
	ld.uh	%r5,[%r12]	; 	xld.uh %r5, [%r12+0]	;// v0->x
	add %r4, %r5
	ext	0x4		; 	xld.w %r10, [%r14+4]	;// param->surface_vbuff
	ld.w	%r10,[%r14]
	add %r10, %r4
	ext	0x8		; 	xld.w %r11, [%r14+8]	;// param->surface_zbuff
	ld.w	%r11,[%r14]
	add %r11, %r4
	;// %r10 = vptr
	;// %r11 = zptr
	;// %r5  = v0->x

	;// 厲DDAZbgAbvB
	ld.uh	%r15,[%r13]	; 	xld.uh %r15, [%r13+0]	;// v1->x
	sub %r15, %r5
	jreq	__draw_scanline_wz_color_ret	; 	xjreq __draw_scanline_wz_color_ret
	;// %r15 = nx

	;// DDAZbgAbvB
	;// (DDA.z)
	ext	0x4		; 	xld.uh %r0, [%r12+4]	;// v0->z => cur.z
	ld.uh	%r0,[%r12]
	ext	0x4		; 	xld.uh %r4, [%r13+4]	;// v1->z
	ld.uh	%r4,[%r13]
	sub %r4, %r0
	ld.w	%r13,0x1	; 	xld.w %r13, 1		;// z.v
	jruge	__draw_scanline_wz_color_setup_z	; 	xjruge __draw_scanline_wz_color_setup_z
	not %r4, %r4
	add	%r4,0x1		; 	xadd %r4, %r4, 1
	ld.w	%r13,0x3f	; 	xld.w %r13, -1		;// z.v
__draw_scanline_wz_color_setup_z:
	sll	%r4,0x8		; 	xsll %r4, 16
	sll	%r4,0x8
	ld.w %alr, %r4
	div0u %r15
	div1 %r15		;//  1
	div1 %r15		;//  2
	div1 %r15		;//  3
	div1 %r15		;//  4
	div1 %r15		;//  5
	div1 %r15		;//  6
	div1 %r15		;//  7
	div1 %r15		;//  8
	div1 %r15		;//  9
	div1 %r15		;// 10
	div1 %r15		;// 11
	div1 %r15		;// 12
	div1 %r15		;// 13
	div1 %r15		;// 14
	div1 %r15		;// 15
	div1 %r15		;// 16
	ld.w %r1, %ahr		;// z.n * 2
	add %r1, %r1
	not %r2, %r15		;// z.d
	add	%r2,0x1		; 	xadd %r2, %r2, 1
	ld.w %r6, %alr		;// z.u
	mlt.h %r6, %r13
	ld.w %r6, %alr
	;// %r0  = cur.z
	;// %r1  = DDA.z.n * 2
	;// %r2  = DDA.z.d
	;// %r6  = DDA.z.u
	;// %r13 = DDA.z.v

	;// DDA[vB
	ld.w %r7, %r15
	add %r15, %r15
	ext	0x18		; 	xld.ub %r12, [%r14+24]	;// param->back_color
	ld.ub	%r12,[%r14]
__draw_scanline_wz_color_loop:
	;// %r7  = n
	;// %r15 = nx * 2
	;// %r12 = back_color

	;// yrB
	ld.uh %r4, %r0		;// zval
	srl	%r4,0x8		; 	xsrl %r4, 8
	ld.ub	%r5,[%r11]	; 	xld.ub %r5, [%r11]	;// *zptr
	cmp %r4, %r5
	jrugt	__draw_scanline_wz_color_skip	; 	xjrugt __draw_scanline_wz_color_skip
	;// %r4 = zval

	;// eNX`ȂAtFCX̔wiFŕ`܂B
	ld.b	[%r10],%r12	; 	xld.b [%r10], %r12	;// *vptr
	ld.b	[%r11],%r4	; 	xld.b [%r11], %r4	;// *zptr
__draw_scanline_wz_color_skip:

	;// obt@|C^i߂܂B
	add	%r10,0x1	; 	xadd %r10, %r10, 1
	add	%r11,0x1	; 	xadd %r11, %r11, 1

	;// DDAXebvsB
	;// (DDA.z)
	add %r0, %r6		;// cur.z += z.u
	add %r2, %r1		;// z.d += z.n * 2
	jruge	__draw_scanline_wz_color_step_z	; 	xjruge __draw_scanline_wz_color_step_z ;// !C
	add %r0, %r13		;// cur.z += z.v
	sub %r2, %r15		;// z.d -= nx * 2
__draw_scanline_wz_color_step_z:

	sub	%r7,0x1		; 	xsub %r7, %r7, 1
	jrne	__draw_scanline_wz_color_loop	; 	xjrne __draw_scanline_wz_color_loop

__draw_scanline_wz_color_ret:
	popn	%r2
	ret
	
