/*	
 *	framgym.c
 *
 *	P/ECE GYM Driver
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Thu Dec 9 18:16:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clip.h"

/* * YM2612\̂RAMɒuȂƁAxԂɍ܂B
 * - {constł͂܂񂪁A.codeZNVɔzu邽߁AUconstƂĂ܂B
 *   (RAMɔzuw肵W[.codeZNV݂̂AۂɍRAMɒu܂B)
 * - P/ECE.code,.data,.bssׂĂRAMɓWJĎŝŁAconstł\łB
 *   Win32constϐł悤łAÔWin32łconstO܂B
 */
#ifdef PIECE
const YM2612 gym_ym2612 = { 0 }; /* qK{Bq.bssɓĂ܂ */
#else /*PIECE*/
      YM2612 gym_ym2612;
#endif /*PIECE*/

/****************************************************************************
 *	GYMhCo֐
 ****************************************************************************/

/* daccntTvDACo͂GYMBUFLEN_60TvɈL΂܂B */
#ifndef PIECE
void
gym_dacmix(short dst[/*GYMBUFLEN_60*/], const short src[/*daccnt*/], int daccnt)
{
	int d;
	int n;
	short v;

	n = GYMBUFLEN_60;
	d = 0;
	v = 0; /* daccnt=0̏ꍇ̂ */
	do {
		d -= daccnt;
		if(d < 0) {
			d += GYMBUFLEN_60;
			v = *src++;
		}
		*dst++ = v;
	} while(--n);
}
#else /*PIECE*/
asm("
	.code
	.align 1
	.global gym_dacmix
gym_dacmix:
	; %r12 = dst
	; %r13 = src
	; %r14 = daccnt
	xld.w %r4, 267			; GYMBUFLEN_60 (clipgym.h̒`ƍĂ邱!!)
	ld.w %r5, %r4			; n = GYMBUFLEN_60
	xld.w %r6, 0			; d = 0
	xld.w %r7, 0			; v = 0
gym_dacmix_L10:				; do {
	sub %r6, %r14			;   d -= daccnt
	xjrge gym_dacmix_L20		;   if(d < 0) {
	add %r6, %r4			;     d += GYMBUFLEN_60
	ld.h %r7, [%r13]+		;     v = *src++
gym_dacmix_L20:				;   }
	ld.h [%r12]+, %r7		;   *dst++ = v
	xsub %r5, %r5, 1		; } while(--n)
	xjrne gym_dacmix_L10
	ret
");
#endif /*PIECE*/

/* YM2612:SN76489:DACK؂Ȕ䗦Ń~LVOāAo̓obt@փRs[܂B */
#ifndef PIECE
void
gym_copy(const short src1[/*GYMBUFLEN*/], const short src2[/*GYMBUFLEN*/], const short src3[/*GYMBUFLEN*/], short dst[/*GYMBUFLEN*/])
{
	int n;
	int v;

	n = GYMBUFLEN;
	do {
		v = (*src1++ >> 0/**/)	/* YM2612 */
		  + (*src2++ >> 2/**/)	/* SN76489 */
		  + (*src3++ >> 0/**/);	/* DAC */
		if(v >  32767) v =  32767;
		if(v < -32768) v = -32768;
		*dst++ = v;
	} while(--n);
}
#else /*PIECE*/
asm("
	.code
	.align 1
	.global gym_copy
gym_copy:
	; %r12 = src1 (YM2612)
	; %r13 = src2 (SN76489)
	; %r14 = src3 (DAC)
	; %r15 = dst
	xld.w %r4, 320			; GYMBUFLEN
	xld.w %r10, 32767
	not %r11, %r10			; -32768
gym_copy_L10:
	ld.h %r5, [%r12]+		; YM2612  = *src1++
	ld.h %r6, [%r13]+		; SN76489 = *src2++
	ld.h %r7, [%r14]+		; DAC     = *src3++
	xsra %r6, 2			; v = YM2612 + (SN76489 >> 2) + DAC
	add %r5, %r6
	add %r5, %r7
	cmp %r5, %r10
	xjrle.d gym_copy_L20
	cmp %r5, %r11			; *delay*
	ld.w %r5, %r10
gym_copy_L20:
	xjrge.d gym_copy_L30
	sub %r4, 1			; *delay*
	ld.w %r5, %r11
gym_copy_L30:
	ld.h [%r15]+, %r5
	xjrne gym_copy_L10
	ret
");
#endif /*PIECE*/
